#ifndef AT91SAM7X256_H_
#define AT91SAM7X256_H_

/* Parallel Input/Output Controller (PIO) */

#define PIOA_BASE_ADDR		0xFFFFF400

#define PIOA_PIO_PER		(*((volatile unsigned int*)(PIOA_BASE_ADDR + 0x0000)))
#define PIOA_PIO_PDR		(*((volatile unsigned int*)(PIOA_BASE_ADDR + 0x0004)))
#define PIOA_PIO_PSR		(*((volatile unsigned int*)(PIOA_BASE_ADDR + 0x0008)))
#define PIOA_PIO_OER		(*((volatile unsigned int*)(PIOA_BASE_ADDR + 0x0010)))
#define PIOA_PIO_ODR		(*((volatile unsigned int*)(PIOA_BASE_ADDR + 0x0014)))
#define PIOA_PIO_OSR		(*((volatile unsigned int*)(PIOA_BASE_ADDR + 0x0018)))
#define PIOA_PIO_IFER		(*((volatile unsigned int*)(PIOA_BASE_ADDR + 0x0020)))
#define PIOA_PIO_IFDR		(*((volatile unsigned int*)(PIOA_BASE_ADDR + 0x0024)))
#define PIOA_PIO_IFSR		(*((volatile unsigned int*)(PIOA_BASE_ADDR + 0x0028)))
#define PIOA_PIO_SODR		(*((volatile unsigned int*)(PIOA_BASE_ADDR + 0x0030)))
#define PIOA_PIO_CODR		(*((volatile unsigned int*)(PIOA_BASE_ADDR + 0x0034)))
#define PIOA_PIO_ODSR		(*((volatile unsigned int*)(PIOA_BASE_ADDR + 0x0038)))
#define PIOA_PIO_PDSR		(*((volatile unsigned int*)(PIOA_BASE_ADDR + 0x003C)))
#define PIOA_PIO_IER		(*((volatile unsigned int*)(PIOA_BASE_ADDR + 0x0040)))
#define PIOA_PIO_IDR		(*((volatile unsigned int*)(PIOA_BASE_ADDR + 0x0044)))
#define PIOA_PIO_IMR		(*((volatile unsigned int*)(PIOA_BASE_ADDR + 0x0048)))
#define PIOA_PIO_ISR		(*((volatile unsigned int*)(PIOA_BASE_ADDR + 0x004C)))
#define PIOA_PIO_MDER		(*((volatile unsigned int*)(PIOA_BASE_ADDR + 0x0050)))
#define PIOA_PIO_MDDR		(*((volatile unsigned int*)(PIOA_BASE_ADDR + 0x0054)))
#define PIOA_PIO_MDSR		(*((volatile unsigned int*)(PIOA_BASE_ADDR + 0x0058)))
#define PIOA_PIO_PUDR		(*((volatile unsigned int*)(PIOA_BASE_ADDR + 0x0060)))
#define PIOA_PIO_PUER		(*((volatile unsigned int*)(PIOA_BASE_ADDR + 0x0064)))
#define PIOA_PIO_PUSR		(*((volatile unsigned int*)(PIOA_BASE_ADDR + 0x0068)))
#define PIOA_PIO_ASR		(*((volatile unsigned int*)(PIOA_BASE_ADDR + 0x0070)))
#define PIOA_PIO_BSR		(*((volatile unsigned int*)(PIOA_BASE_ADDR + 0x0074)))
#define PIOA_PIO_ABSR		(*((volatile unsigned int*)(PIOA_BASE_ADDR + 0x0078)))
#define PIOA_PIO_OWER		(*((volatile unsigned int*)(PIOA_BASE_ADDR + 0x00A0)))
#define PIOA_PIO_OWDR		(*((volatile unsigned int*)(PIOA_BASE_ADDR + 0x00A4)))
#define PIOA_PIO_OWSR		(*((volatile unsigned int*)(PIOA_BASE_ADDR + 0x00A8)))

#define PIOB_BASE_ADDR		0xFFFFF600

#define PIOB_PIO_PER		(*((volatile unsigned int*)(PIOB_BASE_ADDR + 0x0000)))
#define PIOB_PIO_PDR		(*((volatile unsigned int*)(PIOB_BASE_ADDR + 0x0004)))
#define PIOB_PIO_PSR		(*((volatile unsigned int*)(PIOB_BASE_ADDR + 0x0008)))
#define PIOB_PIO_OER		(*((volatile unsigned int*)(PIOB_BASE_ADDR + 0x0010)))
#define PIOB_PIO_ODR		(*((volatile unsigned int*)(PIOB_BASE_ADDR + 0x0014)))
#define PIOB_PIO_OSR		(*((volatile unsigned int*)(PIOB_BASE_ADDR + 0x0018)))
#define PIOB_PIO_IFER		(*((volatile unsigned int*)(PIOB_BASE_ADDR + 0x0020)))
#define PIOB_PIO_IFDR		(*((volatile unsigned int*)(PIOB_BASE_ADDR + 0x0024)))
#define PIOB_PIO_IFSR		(*((volatile unsigned int*)(PIOB_BASE_ADDR + 0x0028)))
#define PIOB_PIO_SODR		(*((volatile unsigned int*)(PIOB_BASE_ADDR + 0x0030)))
#define PIOB_PIO_CODR		(*((volatile unsigned int*)(PIOB_BASE_ADDR + 0x0034)))
#define PIOB_PIO_ODSR		(*((volatile unsigned int*)(PIOB_BASE_ADDR + 0x0038)))
#define PIOB_PIO_PDSR		(*((volatile unsigned int*)(PIOB_BASE_ADDR + 0x003C)))
#define PIOB_PIO_IER		(*((volatile unsigned int*)(PIOB_BASE_ADDR + 0x0040)))
#define PIOB_PIO_IDR		(*((volatile unsigned int*)(PIOB_BASE_ADDR + 0x0044)))
#define PIOB_PIO_IMR		(*((volatile unsigned int*)(PIOB_BASE_ADDR + 0x0048)))
#define PIOB_PIO_ISR		(*((volatile unsigned int*)(PIOB_BASE_ADDR + 0x004C)))
#define PIOB_PIO_MDER		(*((volatile unsigned int*)(PIOB_BASE_ADDR + 0x0050)))
#define PIOB_PIO_MDDR		(*((volatile unsigned int*)(PIOB_BASE_ADDR + 0x0054)))
#define PIOB_PIO_MDSR		(*((volatile unsigned int*)(PIOB_BASE_ADDR + 0x0058)))
#define PIOB_PIO_PUDR		(*((volatile unsigned int*)(PIOB_BASE_ADDR + 0x0060)))
#define PIOB_PIO_PUER		(*((volatile unsigned int*)(PIOB_BASE_ADDR + 0x0064)))
#define PIOB_PIO_PUSR		(*((volatile unsigned int*)(PIOB_BASE_ADDR + 0x0068)))
#define PIOB_PIO_ASR		(*((volatile unsigned int*)(PIOB_BASE_ADDR + 0x0070)))
#define PIOB_PIO_BSR		(*((volatile unsigned int*)(PIOB_BASE_ADDR + 0x0074)))
#define PIOB_PIO_ABSR		(*((volatile unsigned int*)(PIOB_BASE_ADDR + 0x0078)))
#define PIOB_PIO_OWER		(*((volatile unsigned int*)(PIOB_BASE_ADDR + 0x00A0)))
#define PIOB_PIO_OWDR		(*((volatile unsigned int*)(PIOB_BASE_ADDR + 0x00A4)))
#define PIOB_PIO_OWSR		(*((volatile unsigned int*)(PIOB_BASE_ADDR + 0x00A8)))

/* Watchdog timer (WDT) */

#define WDT_BASE_ADDR		0xFFFFFD40

#define WDT_CR				(*((volatile unsigned int*)(WDT_BASE_ADDR + 0x00)))
#define WDT_MR				(*((volatile unsigned int*)(WDT_BASE_ADDR + 0x04)))
#define WDT_SR				(*((volatile unsigned int*)(WDT_BASE_ADDR + 0x08)))

/* Universal Synchronous Asynchronous Receiver Transceiver (USART) */

#define USART0_BASE_ADDR	0xFFFC0000

#define USART0_CR			(*((volatile unsigned int*)(USART0_BASE_ADDR + 0x0000)))
#define USART0_MR			(*((volatile unsigned int*)(USART0_BASE_ADDR + 0x0004)))
#define USART0_IER			(*((volatile unsigned int*)(USART0_BASE_ADDR + 0x0008)))
#define USART0_IDR			(*((volatile unsigned int*)(USART0_BASE_ADDR + 0x000C)))
#define USART0_IMR			(*((volatile unsigned int*)(USART0_BASE_ADDR + 0x0010)))
#define USART0_CSR			(*((volatile unsigned int*)(USART0_BASE_ADDR + 0x0014)))
#define USART0_RHR			(*((volatile unsigned int*)(USART0_BASE_ADDR + 0x0018)))
#define USART0_THR			(*((volatile unsigned int*)(USART0_BASE_ADDR + 0x001C)))
#define USART0_BRGR			(*((volatile unsigned int*)(USART0_BASE_ADDR + 0x0020)))
#define USART0_RTOR			(*((volatile unsigned int*)(USART0_BASE_ADDR + 0x0024)))
#define USART0_TTGR			(*((volatile unsigned int*)(USART0_BASE_ADDR + 0x0028)))
#define USART0_FIDI			(*((volatile unsigned int*)(USART0_BASE_ADDR + 0x0040)))
#define USART0_NER			(*((volatile unsigned int*)(USART0_BASE_ADDR + 0x0044)))
#define USART0_IF			(*((volatile unsigned int*)(USART0_BASE_ADDR + 0x004C)))

#define USART1_BASE_ADDR	0xFFFC4000

#define USART1_CR			(*((volatile unsigned int*)(USART1_BASE_ADDR + 0x0000)))
#define USART1_MR			(*((volatile unsigned int*)(USART1_BASE_ADDR + 0x0004)))
#define USART1_IER			(*((volatile unsigned int*)(USART1_BASE_ADDR + 0x0008)))
#define USART1_IDR			(*((volatile unsigned int*)(USART1_BASE_ADDR + 0x000C)))
#define USART1_IMR			(*((volatile unsigned int*)(USART1_BASE_ADDR + 0x0010)))
#define USART1_CSR			(*((volatile unsigned int*)(USART1_BASE_ADDR + 0x0014)))
#define USART1_RHR			(*((volatile unsigned int*)(USART1_BASE_ADDR + 0x0018)))
#define USART1_THR			(*((volatile unsigned int*)(USART1_BASE_ADDR + 0x001C)))
#define USART1_BRGR			(*((volatile unsigned int*)(USART1_BASE_ADDR + 0x0020)))
#define USART1_RTOR			(*((volatile unsigned int*)(USART1_BASE_ADDR + 0x0024)))
#define USART1_TTGR			(*((volatile unsigned int*)(USART1_BASE_ADDR + 0x0028)))
#define USART1_FIDI			(*((volatile unsigned int*)(USART1_BASE_ADDR + 0x0040)))
#define USART1_NER			(*((volatile unsigned int*)(USART1_BASE_ADDR + 0x0044)))
#define USART1_IF			(*((volatile unsigned int*)(USART1_BASE_ADDR + 0x004C)))

#endif // AT91SAM7X256_H_
